<?php

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// process form
$thisplugin->add_action('page_start','lb_page_start');
function lb_page_start()
{
    global $FAVPICS, $CONFIG;

    $superCage = Inspekt::makeSuperCage();
    if ($superCage->post->getRaw('form_name') == 'fav_control')
    {
        $add_ids = $superCage->post->getRaw('fav_add');
        $del_ids = $superCage->post->getRaw('fav_del');

        foreach ($add_ids as $pid)
        {
            if ( ! in_array($pid, $FAVPICS)) {
                $FAVPICS[] = $pid;
            }
        }

        foreach ($del_ids as $pid)
        {
            if (in_array($pid, $FAVPICS))
            {
                $key = array_search($pid, $FAVPICS);
                unset($FAVPICS[$key]);
            }
        }

        $data    = base64_encode(serialize($FAVPICS));
        setcookie($CONFIG['cookie_name'] . '_fav', $data, time() + 86400 * 30, $CONFIG['cookie_path']);
        // If the user is logged in then put it in the DB
        if (USER_ID > 0)
        {
            $sql = "UPDATE {$CONFIG['TABLE_FAVPICS']} SET user_favpics = '$data' WHERE user_id = " . USER_ID;
            cpg_db_query($sql);

            $sql = "SELECT * FROM {$CONFIG['TABLE_FAVPICS']} WHERE user_id = " . USER_ID;
            $result = cpg_db_query($sql);

            // User never stored a fav... so insert new row
            if ( ! mysql_num_rows($result))
            {
                $sql = "INSERT INTO {$CONFIG['TABLE_FAVPICS']} (user_id, user_favpics) VALUES (" . USER_ID . ", '$data')";
                cpg_db_query($sql);
            }
        }
    }
}

// list of button
$thisplugin->add_filter('thumb_caption', 'lb_thumb_caption');
function lb_thumb_caption($rowset)
{
    global $CONFIG;
    global $FAVPICS;
    global $REFERER;

    foreach ($rowset as $index => $row)
    {
        if ( ! in_array($row['pid'], $FAVPICS))
        {
            $in   = FALSE;
            $text = 'Add to Lightbox';
        }
        else
        {
            $in   = TRUE;
            $text = 'Remove from Lightbox';
        }
        $rowset[$index]['caption_text'] .=
            "</a>".
            "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr><td><span class=\"thumb_title\">".
            $text . "</span></td><td><input type=\"checkbox\" name=\"fav_".($in ? 'del' : 'add')."[]\" value=\"{$row['pid']}\" /></td></tr></table>"."<a>";
    }
    return $rowset;
}

$thisplugin->add_action('theme_thumbnails_wrapper_start', 'lb_theme_thumbnails_wrapper_start');
function lb_theme_thumbnails_wrapper_start()
{
    global $REFERER;
    echo '<form action="'.urldecode($REFERER).'" method="post">';
    echo '<input type="hidden" name="form_name" value="fav_control" />';
}

$thisplugin->add_action('theme_thumbnails_wrapper_end', 'lb_theme_thumbnails_wrapper_end');
function lb_theme_thumbnails_wrapper_end()
{
    starttable(-1, 'Lightbox Actions');
    echo <<<EOT
<tr>
    <td class="tableb">
        <input class="button" type="submit" name="submit" value="Process Selected" />
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        <button class="button" onclick="$('input[name^=fav_]').attr('checked', 'checked');return false;">Select All</button>
        <button class="button" onclick="$('input[name^=fav_add]').attr('checked', 'checked');return false;">Select All Add</button>
        <button class="button" onclick="$('input[name^=fav_del]').attr('checked', 'checked');return false;">Select All Remove</button>
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        <button class="button" onclick="$('input[name^=fav_]').attr('checked', false);return false;">Deselect All</button>
        <button class="button" onclick="$('input[name^=fav_add]').attr('checked', false);return false;">Deselect All Add</button>
        <button class="button" onclick="$('input[name^=fav_del]').attr('checked', false);return false;">Deselect All Remove</button>
    </td>
</tr>
EOT;
    endtable();
    echo '</form>';
}

?>
